stages:
  - 🧨unit-tests
  - 🔎code-quality
  - 🐳build

variables:
  CONTAINER_PORT: 8080
  EXPOSED_PORT: 80

#-----------------------------------------------------------------------------------------
# Includes (remote is possible)
#-----------------------------------------------------------------------------------------
include:
 - local: 'ci/testing/mocha.gitlab-ci.yml'
 - local: 'ci/quality/eslint.gitlab-ci.yml'
 - local: 'ci/metrics/git-quick-stats.gitlab-ci.yml'
 - local: 'ci/kaniko/kaniko.gitlab-ci.yml'

#-----------------------------------------------------------------------------------------
# Tests
#-----------------------------------------------------------------------------------------
🎯:testing:
  stage: 🧨unit-tests
  extends: .mocha:testing
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
    - if: $CI_MERGE_REQUEST_IID

#-----------------------------------------------------------------------------------------
# Quality
#-----------------------------------------------------------------------------------------
🔎:code:quality:eslint:
  stage: 🔎code-quality
  extends: .eslint:analyzer
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
    - if: $CI_MERGE_REQUEST_IID

# metrics
🤖:git-analysis:
  stage: 🔎code-quality
  extends: .git-quick-stats:analyzer
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
    - if: $CI_MERGE_REQUEST_IID

#-----------------------------------------------------------------------------------------
# Docker (Kaniko) builds 🖐️ show the Container Registry
#-----------------------------------------------------------------------------------------
📦:kaniko:build:
  stage: 🐳build
  extends: .kaniko:builder
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
    - if: $CI_MERGE_REQUEST_IID
